function setoutputlog(varargin)
global net outputlog PDPAppdata filevarname;
fileind = find(strcmpi(varargin,'file'));
if isempty(fileind) || fileind+1 > numel(varargin)
   error('Output log cannot be specified without file name');
else
    fi = 0;
    if isempty(outputlog)
       outputlog=struct('file','','process','','frequency','','status','off',...
                    'writemode','text','logopts','off','objects',{},'cobjects',{},...
                    'onreset','clear','plot','off','plotlayout',[],...                    
                    'graphdata',[],'binout',[],'varstruct',{});
    else
        fname = varargin{fileind+1};
        [tf, fi] = ismember (fname,{outputlog.file});
    end
    if fi == 0
       currlog.file = 'log1.mat';
       currlog.process = 'test';
       currlog.frequency = 'pattern';
       currlog.status = 'off';
       currlog.writemode = 'binary';
       currlog.logopts = 'off';
       currlog.objects = [];
       currlog.cobjects = '';
       currlog.onreset = 'clear';       
       currlog.plot = 'off';
       currlog.plotlayout = [];
       currlog.graphdata = []; 
       currlog.binout = [];
       nextlog = numel(outputlog) +1;
    else
       currlog = outputlog(fi);
       nextlog = fi;
    end
end
currlog = parse_pairs(currlog,varargin);
if isempty(currlog.objects)
    return;
end
networks= PDPAppdata.networks;
if fi == 0 || any(strcmpi(currlog.objects, outputlog(fi).objects))
   currlog.varstruct = setwritelog(currlog.objects);
   currlog.cobjects = currlog.objects;
   currlog.cobjects = regexprep(currlog.cobjects,'\(|\)','');
   currlog.cobjects = regexprep(currlog.cobjects,'\.','_');
   currlog.cobjects = regexprep(currlog.cobjects,',','x');
   currlog.cobjects = regexprep(currlog.cobjects,':','_');    
end
% outputlog(lognum).cvars = cvars;
if PDPAppdata.lognetwork 
   fields = fieldnames(rmfield(currlog,{'file','varstruct','cobjects','graphdata','binout'}));
   tempA = struct2cell(rmfield(currlog,{'file','varstruct','cobjects','graphdata','binout'}));
   diffind = 1:numel(tempA);
   if fi > 0
      currlog = orderfields(currlog, outputlog(fi));       
      tempB = struct2cell(rmfield(outputlog(fi),{'file','varstruct','cobjects','graphdata','binout'}));
      diffind = cellfun(@isequal,tempA,tempB); 
      diffind = find(~diffind);     
   end
   if isempty(filevarname)
      statement = sprintf('%s (''file'', ''%s'',',mfilename,currlog.file);
   else
      statement = sprintf('%s (''file'', %s,',mfilename,filevarname);
   end
   for i = 1 : numel(diffind)
       fval =  currlog.(fields{diffind(i)});       
       if iscell(fval)
          fval = sprintf('''%s'',',fval{1:end});
          fval(end)='}';
          fval = strcat('{',fval);
          statement = sprintf('%s''%s'', %s,',statement, ...
                      fields{diffind(i)},fval);
       else
          if ~ischar(fval) && ~isscalar(fval)
             statement = sprintf('%s''%s'', %s,',statement,...
                      fields{diffind(i)},mat2str(fval));
          else
             statement = sprintf('%s''%s'', ''%s'',',statement,...
                      fields{diffind(i)},fval);
          end
       end
   end
   statement= strcat(statement(1:end-1),');');
   if ~isempty(diffind)
%    statement= sprintf('%s(''%s'',%d,''%s'',''%s'',''%s'',''%s'',{%s});',mfilename,filename,...
%                       lognum,procname{:},writefreq,logstatus,logmode,v);
      updatelog(statement);
   end
end
outputlog(nextlog) = currlog;
if strcmpi(outputlog(nextlog).plot,'on')
   if isempty(outputlog(nextlog).graphdata)
      outputlog(nextlog).graphdata = struct('px',[],'py',[],'fighandle',[],...
                                     'axhandle',[],'plotnum',[],'yvariables',{''},'title','',...
                                     'tag','','xlabel','','ylabel','','ylim',[]);
   end
else
   if ~isempty(outputlog(nextlog).graphdata)
      fig = outputlog(nextlog).graphdata.fighandle;
      if ishandle(fig)
         delete (fig);
      end
      outputlog(nextlog).graphdata = [];
   end
end
lnum =numel(net.outputfile)+1;
if ~isempty(net.outputfile)
    [tf, lmatch] = ismember(currlog.file, net.outputfile);
    if (lmatch~=0)
       lnum = lmatch;
    end
end
net.outputfile{lnum}= currlog.file;
networks{net.num}=net;
PDPAppdata.networks = networks;
if ~PDPAppdata.gui
   fprintf(1,'Outputlog %s set for current network\n',currlog.file);
end